package com.vanheusden.pfa;

import java.io.*;
import java.util.*;

class IO_EPDCount extends IO {
	int prevDepth = -1;

	public void progressCallback(String what) {
		Statics.log(what);
	}

	public void progressCallbackDebug(String what) {
		Statics.log(what);
	}

	public void progressCallbackNPS(int nps) throws IOException {
		Statics.log("Nodes/s " + nps);
	}

	public void progressCallbackDepthReached(int depth) throws IOException {
		if (depth != prevDepth) {
			String what = "Depth reached: " + depth + " (thread: " + Thread.currentThread().getName() + ")";
			Statics.log(what);

			prevDepth = depth;
		}
	}

	public IO_EPDCount(String pgnFile, int maxDepth, int maxExtension, boolean random, double maxDuration, final Brain brain, final String boardInit, final boolean ponder, List<String> beepers) throws Exception {
		super(maxDepth, maxExtension, random, maxDuration, brain, ponder, false, beepers);

		Object [] epd = Statics.EPDToScene(boardInit);
		scene = (Scene)epd[0];
		currentPlayer = (PlayerColor)epd[1];

		this.pgnFile = pgnFile;
	}

	public void loop() throws IOException, InterruptedException {
		scene.validateMoves(currentPlayer);

		System.out.println(scene.getMoveList(currentPlayer).size());
	}
}
