package com.vanheusden.pfa;

enum MoveType { REGULAR(0), CASTLING(1), EN_PASSANT(2);
		final byte value;

		MoveType(final int v) {
			value = (byte)v;
		}

		final byte getType() {
			return value;
		}

		final static byte getNullType() {
			return 3;
		}

		static final MoveType getMT(final byte type) {
			switch(type)
			{
				case 0:
					return REGULAR;

				case 1:
					return CASTLING;

				case 2:
					return EN_PASSANT;

				case 3:
					return null;
			}

			return null;
		}
}
