package com.vanheusden.pfa;

import java.io.IOException;

import android.app.Activity;
import android.content.SharedPreferences;

public class PosWrapper implements Runnable {
	PosService ps = null;
	int port = 12366;
	IO_UCI ups = null;
	
	PosWrapper(PosService ps, int port_in, int maxDepth, int maxExtension, boolean random, int maxNProcs, double maxDuration, int transTabSize) {
		this.ps = ps;
		port = port_in;

		System.out.println("Port from preferences: " + port);
		try {
			try {
				ups = new IO_UCI_socket_android(ps, null, maxDepth, maxExtension, random, maxNProcs, maxDuration, port, transTabSize);
			}
			catch(IOException ie) {
				System.out.println("bind to " + port + " failed, retry with 0");
				ups = new IO_UCI_socket_android(ps, null, maxDepth, maxExtension, random, maxNProcs, maxDuration, 0, transTabSize);
				port = ((IO_UCI_socket)ups).getPort();
			}

			ps.sendMessage("Listening on port: " + port);
		}
		catch(IOException ie) {
			ps.sendMessage("FAILED TO LISTEN ON TCP PORT!");
		}
	}

	public int getPort() {
		return port;
	}
	
	public void run() {
		try {
			for(;;) {
				ups.loop();
				((IO_UCI_socket_android)ups).close();
				// ups = new IO_UCI_socket_android(ps, null, 5, 2, true, 0, 30, port);
				Thread.sleep(1);
			}
		}
		catch(Exception e) {
			ps.sendMessage("PosWrapper exception: " + e);
		}
	}
}
