package com.vanheusden.pfa;

final class TTElement {
	private byte [] move;
	private long hash;
	private short score;

	TTElement(final long hash, final int scoreIn, final byte depth, final Move move, final Flag flag, final int ply) {
		this.hash = hash;

		this.move = new byte[5];

		if (move == null)
			this.move[0] = this.move[1] = -1;
		else
			move.toBytes(this.move);

		this.move[3] = depth;
		this.move[4] = flag.getV();

		assert(scoreIn >= -16384);
		assert(scoreIn < 16384);
		//this.score = (short)(isMateScore(scoreIn) ? (scoreIn < 0 ? scoreIn - ply : scoreIn + ply) : scoreIn);
		this.score = (short)scoreIn;

		// if (isMateScore(scoreIn) && scoreIn < 0) assert(scoreIn >= -(10000-ply));
		// if (isMateScore(scoreIn) && scoreIn > 0) assert(scoreIn <= +(10000-ply));

		//if (this.score < -10000 || this.score > 10000)
			//Statics.log("hieraba " + this.score + " " + ply + " " + scoreIn + " " + flag);
	}

	TTElement() {
		this.move = new byte[5];
	}

	void set(final long hash, final int scoreIn, final byte depth, final Move move, final Flag flag, final int ply) {
		this.hash = hash;

		if (move == null)
			this.move[0] = this.move[1] = -1;
		else
			move.toBytes(this.move);

		this.move[3] = depth;
		this.move[4] = flag.getV();

		assert(scoreIn >= -16384);
		assert(scoreIn < 16384);
		//this.score = (short)(isMateScore(scoreIn) ? (scoreIn < 0 ? scoreIn - ply : scoreIn + ply) : scoreIn);
		this.score = (short)scoreIn;
	}

	long getHash() {
		return hash;
	}

	short getEval(final int ply) {
		//short rv = (short)(isMateScore(score) ? (score < 0 ? score + ply : score - ply) : score);

		//if (rv < -10000 || rv > 10000)
			//Statics.log("hierabb " + score + " " + ply + " " + rv);

		return score; //rv;
	}

	short getEvalRaw() {
		return score;
	}

	byte getDepth() {
		return move[3];
	}

	Move getMove() {
		if (move[0] != -1 && move[1] != -1)
			return new Move(move);

		return null;
	}

	Flag getFlag() {
		return Flag.getFlag(move[4]);
	}

	boolean isMateScore(final int score) {
		return score >= 9000 || score <= -9000;
	}
}
